#ifndef INCLUDES_H
#define INCLUDES_H

#ifndef MAIN_H
#include "main.h"
#endif

#ifndef FILE_H
#include "File.h"
#endif

/************************************************************************/

struct IncludeFileNode
  {
    struct AnyNode AnyNode;	/* name is filename (dos/dos.h) */
    char *LinkName;
  };

extern struct AVLTree IncludeFileTree;

/************************************************************************/

struct IncludeItemNode
  {
    struct AnyNode AnyNode;
    struct IncludeItemNodeNode *Entries;
    int Function;
  };

/************************************************************************/

struct IncludeItemNodeNode
  {
    struct IncludeItemNodeNode *Next;
    struct IncludeFileNode *IncludeFileNode;
    struct IncludeItemNode *IncludeItemNode;
    ULONG Line;
  };

extern struct AVLTree StructureTree;
extern struct AVLTree UnionTree;
extern struct AVLTree TypedefTree;
extern struct AVLTree DefinesTree;

/************************************************************************/

void ProcessIncludeFile1 (char *);
void ProcessIncludeFile2 (struct IncludeFileNode *);

void WriteIdentifier (struct Word *, struct IncludeFileNode *);

/************************************************************************/

#endif /* INCLUDES_H */
